/*>>> MFFA >>>*/
/*
 * $Id: parm.h,v 1.6 2002/02/28 21:55:53 spoel Exp $
 * 
 *                This source code is part of
 * 
 *                 G   R   O   M   A   C   S
 * 
 *          GROningen MAchine for Chemical Simulations
 * 
 *                        VERSION 3.1
 * Copyright (c) 1991-2001, University of Groningen, The Netherlands
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * If you want to redistribute modifications, please consider that
 * scientific software is very special. Version control is crucial -
 * bugs must be traceable. We will be happy to consider code for
 * inclusion in the official distribution, but derived work must not
 * be called official GROMACS. Details are found in the README & COPYING
 * files - if they are missing, get the official version at www.gromacs.org.
 * 
 * To help us fund GROMACS development, we humbly ask that you cite
 * the papers on the package - you can find them in the top README file.
 * 
 * For more info, check our website at http://www.gromacs.org
 * 
 * And Hey:
 * Gnomes, ROck Monsters And Chili Sauce
 */
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/* deformable boundary stuff */

enum{efSPHERE, efLIN, efCILIND};

typedef struct {
  int  TYPE; 
  int  AXIS;
  int  index_nr_out;
  int  index_nr_in;
  real pos_in;
  real pos_out;
  real GRID;
  real a_out;
  real b_out;
  real a_in;
  real b_in;
  real CUTOFF;
  rvec center;
} MFFA_BOUNDARY_META;

typedef struct {
	MFFA_BOUNDARY_META meta;
	real *F_bounds;
} MFFA_BOUNDARY;

typedef struct {
  int   size_ndx;
  bool  bSDB;
  bool  bPC;
  bool  bNDX;
  bool  bQUENCH;
  int PNUMB;
  /*radial boundary forces*/
  real Fb_in;
  real Fb_out;
  /*virial pressure*/ 
  real P_int;
  tensor int_vir;
} MFFA_META;

typedef struct {
  real TFb_in;
  real TFb_out;
  real TPb_in;
  real TPb_out;
  real AREA_in;
  real AREA_out;
} MFFA_DYNAMIC;

typedef struct {
	MPI_Datatype meta;
	MPI_Datatype boundary_meta;
	MPI_Datatype dynamic;
} MFFA_MPI;

typedef struct {
	MFFA_META      meta;
	MFFA_BOUNDARY  *boundary;
	MFFA_DYNAMIC   *dynamic;
	char          **filenames;
	int           **index;
	MFFA_MPI        mpi;
} MFFA;

/*<<< MFFA <<<*/

